;                               LCD_routines.INC
;******************************************************************************                         						
; Pour utiliser cette routine ecrire #include LCD.asm je vous conseillle
; de placer cette ligne juste avant la directive END du programme principal
; la routine s'occupe de  mettre en sortie les pins utilises 
;
; si vous n'avez pas besoin de lire dans l'afficheur, pour lire la position du curseur,
; par exemple, vous pouvez vous passer de LCD_RW qu'il suffit de relier  la masse
; 
;	au maximum, 5 niveaux stacks sont utiliss
;
;	Les commandes LCD:
;	LCDinit : initialisation de l'afficheur
;	LCDchar : envoi un caractere ( contenu dans w ) sur l'afficheur
;	LCDins  : envoi une commande ( contenue dans w)  l'afficheur
;	LCDcls  : efface l'afficheur
;	LCDcls2 : efface la deuxieme ligne de l'afficheur
;	LCDhome : renvoi le curseur en haut a gauche
;	LCDlin1 : renvoi le curseur au debut de la ligne 1
;	LCDlin2 : renvoi le curseur au debut de la ligne 2
;
;***********************************************************************************

START

LCDcls  movlw	D'01'		; effacement de l'ecran
	call	LCDins
	goto	LCDlo5		; temporisation 1,5ms ,return dans la tempo
LCDcls2 movlw	D'16'		; effacement de la deuxieme ligne
	movwf	LCDtmp2
	movlw	0xC0
	call	LCDins
	call	LCDlo5		; temporisation 1,5ms ,return dans la tempo
LCDcl21	movlw	' '
	call	LCDchar
	decfsz	LCDtmp2,f
	goto	LCDcl21
LCDlin2	movlw	0xC0
	call	LCDins
	goto	LCDlo5		; temporisation 1,5ms ,return dans la tempo
LCDhome movlw	D'02'
	call	LCDins
	goto	LCDlo5		; temporisation 1,5ms ,return dans la tempo
LCDlin1	movlw	0x80
	call	LCDins
	goto	LCDlo5		; temporisation 1,5ms ,return dans la tempo

LCDchar	movwf	LCDtmp
	call	TEST_BF		; tempo 100s ou teste de Busy Flag 
	;ENDIF
	bsf     LCD_RS
	call	LCD_envoie_octet
	return

LCDinit		
	bcf     LCD_E		; on met en sortie toutes les pins utilises
	bcf     LCD_RS
;	ENDIF
	bcf		DATA_LCD7	
	bcf		DATA_LCD6
	bcf		DATA_LCD5
	bcf		DATA_LCD4
	bcf		DATA_LCD7
	bcf		DATA_LCD6
	bsf		DATA_LCD5
	bsf		DATA_LCD4
	bcf     LCD_E
	bcf     LCD_RS
;	ENDIF
	call	LCDlo5		; temporisation 15ms
	bsf     LCD_E
	nop
	bcf     LCD_E		; validation valeur H'3'
	movlw   d'252'
	movwf   LCDt1
	movlw   D'04'
	call	LCDlo2		; temporisation 4ms
	bsf     LCD_E
	nop
	bcf     LCD_E		; validation valeur H'3'
	call 	TEST_BF		; tempo 100s ou teste de Busy Flag
	bsf     LCD_E
	nop
	bcf     LCD_E		; validation valeur H'3'
	call 	TEST_BF		; tempo 100s ou teste de Busy Flag
	bcf		DATA_LCD4
	bsf     LCD_E
	nop
	bcf     LCD_E		; validation valeur H'2'
	movlw   0x028		; Envoi de la commande Fonction 4-bit , Font, Nombre de lignes
	call    LCDins
	movlw   0x008		; display off
	call    LCDins
	movlw   0x00C		; display on ( 0x00E pour cursor on , 0x00F pour curseur clign. )
	call    LCDins
	movlw   0x006
LCDins	movwf   LCDtmp
	call 	TEST_BF		; tempo 100s ou teste de Busy Flag 
;	ENDIF
	bcf     LCD_RS
	call	LCD_envoie_octet
	return

LCD_envoie_octet
	bcf	DATA_LCD7	; on met  0 les sorties
	bcf	DATA_LCD6
	bcf	DATA_LCD5
	bcf	DATA_LCD4

	btfsc	LCDtmp,7	; on teste le bit 7 du caractere
	bsf	DATA_LCD7	; il est  1 donc sortie correspondante  1
	btfsc	LCDtmp,6
	bsf	DATA_LCD6
	btfsc	LCDtmp,5
	bsf	DATA_LCD5
	btfsc	LCDtmp,4
	bsf	DATA_LCD4
	bsf	LCD_E
	nop
	bcf	LCD_E		; validation du premier quartet

	bcf	DATA_LCD7	; on remet  0 les sorties
	bcf	DATA_LCD6
	bcf	DATA_LCD5
	bcf	DATA_LCD4

	btfsc	LCDtmp,3
	bsf	DATA_LCD7
	btfsc	LCDtmp,2
	bsf	DATA_LCD6
	btfsc	LCDtmp,1
	bsf	DATA_LCD5
	btfsc	LCDtmp,0
	bsf	DATA_LCD4
	bsf	LCD_E
	nop
	bcf	LCD_E		; validation du second quartet
	return

LCDlo2	movwf   LCDt2		; temporisation 4ms
	movlw   D'01'
	movwf   LCDt3
	movwf   LCDt4
LCDlo3	nop             
	decfsz  LCDt1,f
	goto    LCDlo3
	decfsz  LCDt2,f
	goto    LCDlo3
	decfsz  LCDt3,f
	goto    LCDlo3
	decfsz  LCDt4,f
	goto    LCDlo3
	return
LCDlo4	movlw   d'22'		; tempo 100s ou teste de Busy Flag 
	movwf   LCDt1
	movlw   d'01'
	goto	LCDlo2
LCDlo5	movlw   d'156'		; temporisation 1,5ms
	movwf   LCDt1
	movlw   D'15'
	goto	LCDlo2


TEST_BF				; sous routine de test de Busy Flag
	bsf	DATA_LCD7
	bsf	DATA_LCD6
	bsf	DATA_LCD5
	bsf	DATA_LCD4
	bcf	LCD_RS
	bsf	LCD_E		; pour lire BF et 3  bits MSB de l'adresse
	nop 
	btfsc	DATA_LCD7
	bcf	LCD_E
	nop
	bsf	LCD_E		; pour lire 4  bits LSB de l'adresse
	nop
	bcf	LCD_E		
	goto	$-7
	bcf	DATA_LCD7
	bcf	DATA_LCD6
	bcf	DATA_LCD5
	bcf	DATA_LCD4


	;ELSE
	call	LCDlo4		; tempo 100s , remplace l'attente Wait_Busy de l'afficheur


	;ENDIF
	return

