;                                 Message.inc
;                           		
;             ROUTINES DE LECTURE ET D'AFFICHAGE DES MESSAGES TEXTES
; 
;************************************************************************************
; Message: Cette routine affiche sur le LCD le message dont le dbut est indiqu dans 
; l'accumulateur PCL. La fin du message est spcifie par le code 0x00


Affiche_message   					
  	call    Messages    			; charge l'adresse du premier carctre puis des 
    								; caractres de sortie suivants. La directive 
    								; 'dt' retourne automatiquement autant de 
    								; caractres que le message en contient (retlw)
    xorlw	0x00					; permet en 1 seule instruction de positionner Z
    btfss   STATUS,Z          		; teste si c'est le dernier caractre du message
    goto    Pas_dernier				; Z=0, pas dernier --> "Pas_dernier"
    return							; Z=1, dernier --> retour au programme 
Pas_dernier		
	call    LCDchar	      			; Affiche le carctre sur le LCD
	call	DELAI25					; temporisation 25ms
    incf    temporaire,F    		; caractre suivant
	movf	temporaire,w			; dans w
    goto    Affiche_message			; retour

;************************************************************************************
;                        SEQUENCES D'AFFICHAGE DES MESSAGES                         *
;************************************************************************************
MARCHE
	movlw	0x3						; pour une question de commodit, les messages
	movwf	PCLATH					; sont tous groups dans le dernier bloc  
									; l'adresse 0x300 ce qui nous permettrait d'crire
									; 256 caractres.

	movlw   b'00000001' 			; efface LCD et Home.
   	call    LCDins					; ecrit commande sur LCD

	movlw	b'11001111'				; positionne le curseur sur le 16e (Adresse=CF)
	call	LCDins					; caractre de la deuxieme ligne

	movlw   b'00000111' 			; dcrmente le curseur, mode normal
    call    LCDins					; ecrit commande sur LCD

	movlw   b'00001100' 			; Afficheur ON, curseur ON, Clignotemnet OFF
	call    LCDins					; ecrit commande sur LCD

	movlw	Message_0				; charge l'adresse de Message_0 dans w
	movwf	temporaire				; sauvegarde l'adresse dans temporaire
	call	Affiche_message			; appelle la procdure d'affichage	
	call	DELAI1					; temporisation 1s
	call	DELAI1					; temporisation 1s
	return							; retour

ARRET	
	movlw	0x3						; pour une question de commodit, les messages
	movwf	PCLATH					; sont tous groups dans le dernier bloc						

	movlw   b'00000001' 			; efface LCD et Home.
   	call    LCDins					; ecrit commande sur LCD

	movlw	b'11001111'				; positionne le curseur sur le 16e (Adresse=CF)
	call	LCDins					; caractre de la deuxieme ligne

	movlw   b'00000111' 			; dcrmente le curseur, mode normal
    call    LCDins					; ecrit commande sur LCD

	movlw   b'00001100' 			; Afficheur ON, curseur ON, Clignotemnet OFF
	call    LCDins					; ecrit commande sur LCD

	movlw	Message_1				; charge l'adresse de Message_1 dans w
	movwf	temporaire				; sauvegarde l'adresse dans temporaire
	call	Affiche_message			; appelle la procdure d'affichage
	call	DELAI1					; temporisation 1s
	call	DELAI1					; temporisation 1s
	return							; retour

	
;************************************************************************************

; Dlai de 1s
DELAI1
			movlw	d'6'			; charge 6 
            movwf	Tempo_1_MES		; dans registre Tempo_1
DELAI1_1
			movlw	d'235'			; charge 235 
            movwf	Tempo_2_MES		; dans registre Tempo_2
DELAI1_2
			movlw	d'235'			; charge 235
			movwf	Tempo_3_MES		; dans registre Tempo_3	
DELAI1_3
			clrwdt
			decfsz	Tempo_3_MES,F	; decremente Tempo_3 et teste
			goto	DELAI1_3		; pas nul, boucler sur DELAI_5_3
			decfsz	Tempo_2_MES,F	; nul, decremente Tempo_2 et teste
			goto	DELAI1_2		; pas nul, boucler sur DELAI_5_2
			decfsz	Tempo_1_MES,F	; nul, decremente Tempo_1 et teste
			goto	DELAI1_1		; pas nul, boucler sur DELAI_5_1
			return					; nul, retour
			
;*************************************************************************************
; Dlai de 25ms
DELAI25
			movlw	d'36'			; charge 36 
            movwf	Tempo_1_MES		; dans registre Tempo_1
DELAI25_1
			movlw	d'230'			; charge 230 
            movwf	Tempo_2_MES		; dans registre Tempo_2
DELAI25_2
			clrwdt
			decfsz	Tempo_2_MES,F	; dcrmente et teste Tempo_2
			goto	DELAI25_2		; pas nul, boucler sur DELAI25_2
			decfsz	Tempo_1_MES,F	; nul, decremente Tempo_1 et teste
			goto	DELAI25_1		; pas nul, boucler sur DELAI25_1
			return					; nul, retour
			
			
;************************************************************************************
;	org	0x300						; saut au dernier bloc de la page 0	; on dispose 
									; ainsi de 255 emplacements soit 255 caractres 
									; pour nos messages	
;************************************************************************************
;                    ROUTINE DE LECTURE DES CARACTERES DES MESSAGES                 *
;************************************************************************************
; Selon la valeur contenue dans le registre W, le caractre  afficher est renvoy 

Messages	
	movwf	PCL						; sauve l'adresse du dbut du message  afficher
									; dans l'accumulateur PCL

;************************************************************************************
; Libell des messages utilisant la directive 'dt' et le caractre 0x00 fin 
; de message

Message_0							; 15 caractres
				dt	"DEMARRE VENTILO",0x00

Message_1							; 13 caractres
				dt	"ARRET VENTILO",0x00

	
