;                       Routine d'affichage sur le LCD.INC                            
; ********************************************************************************
; Mise en forme des donnes des  2 octets rcuprs du composant DALLAS
; Cette routine demande quelques explications ; le rsultat de la conversion tient 
; sur 2 octets : bufferL = octet de poids faible et bufferH = octet de poids fort
; la manip consiste  conserver le quartet 'faible' de 'bufferH' et le quartet fort
; de 'bufferL' (Sans tenir compte du signe si le signe est ngatif)

RANGER
	movlw	b'11110000'			; on charge le masque qui permet d'liminer le 
								; 2e quartet du LSbyte(=bufferL)
	andwf	bufferL,f			; on fait un 'and' avec 'bufferL' on  
								; conserve uniquement les bits 7  4 dans bufferL
	movf	bufferH,W			; on ramne l'octet de poids fort dans w
	andlw	b'00001111'			; on fait un 'and' dans w avec le masque qui permet  
								; d'liminer le premier quartet , on fait
	iorwf	bufferL,f			; un 'ou inclusif' pour reconstituer l'octet unique
	swapf	bufferL,f			; et on swap 'bufferL' pour avoir le rsultat dans 
								; le bon ordre
	movf	bufferL,w			; on ramne 'bufferL' dans w
	movwf	octet__afficher	; on stocke dans variable 'octet__afficher	
	
; ********************************************************************************
; traitement du signe ; seuls sont significatifs les octets <0:6> l'octet de rang 7  
; renseigne sur le signe ; s'il vaut '0' le signe est positif, on n'a pas besoin de
; le supprimer ; s'il vaut '1', le signe est ngatif et il faut supprimer ce 7e bit
; pour qu'il n'intervienne pas dans la valeur
;
; PAS DE VALEUR NEGATIVE !
	
	movf	octet__afficher,w	; rappel dans w
	btfss	octet__afficher,7	; on teste le bit 7 de 'octet__afficher'
	movwf	dividende			; si=0 on copie w dans 'dividende'
	btfsc	octet__afficher,7	; on teste  nouveau
	goto	init				; si=1, on reset
	return	

; ---------------------------------------------------------------------------------
afficher_temp
	clrwdt					 
	clrf	PORTB				; clear PORTB 
	call 	LCDinit				; initialisation du LCD
	movlw	'T'					; charger 'T'
	call	LCDchar				; afficher sur le PORTB
	movlw	'E'					; charger 'E'
	call	LCDchar				; afficher sur le PORTB
	movlw	'M'					; charger 'M'
	call	LCDchar				; afficher sur le PORTB
	movlw	'P'					; charger 'P'
	call	LCDchar				; afficher sur le PORTB
	movlw	' '					; charger 'espace'
	call	LCDchar				; afficher sur le PORTB
	movlw	'='					; charger '='
	call	LCDchar				; afficher sur le PORTB
	movlw	' '					; charger 'espace'
	call	LCDchar				; afficher sur le PORTB 
	movf	dividende,w			; charger la variable 'dividende' 
	call	binDec				; appeler la procdure "binDec"
	movf	dizaine,w			; charger le chiffre des dizaines
	call 	LCDchar				; afficher sur le PORTB
	movf	unites,w			; charger le chiffre des unites
	call 	LCDchar				; afficher sur le PORTB
	movlw	b'11011111'			; charger caractre''
	call 	LCDchar				; afficher sur le PORTB
	movlw	'C'					; afficher caractre temprature 'c'
	call	LCDchar				; afficher sur le PORTB 
	movlw	' '					; charger 'espace' 
	call	LCDchar				; afficher sur le PORTB
	movlw	' '					; charger 'espace' 
	call	LCDchar				; afficher sur le PORTB
	movlw	' '					; charger 'espace' 
	call	LCDchar				; afficher sur le PORTB
	call 	DELAI_2				; dlai de 2 secondes
	btfss	flag,0				; tester le bit0 de la variable flag
	goto	ALARME1				; pour passer soit sur Alarme1
	goto	ALARME2				; soit sur Alarme2

; DELAI_1 : Routine de temporisation d'environ 2s qui utilise les variables 
; Tempo_1, Tempo_2 et Tempo_3
		
DELAI_2		movlw	d'8'			; charge 8 
            movwf	Tempo_1_LCD		; dans registre Tempo_1
DELAI_2_1	movlw	d'250'			; charge 250 
            movwf	Tempo_2_LCD		; dans registre Tempo_2
DELAI_2_2   movlw	d'250'			; charge 250
			movwf	Tempo_3_LCD		; dans registre Tempo_3	
DELAI_2_3	clrwdt
			decfsz	Tempo_3_LCD,F	; decremente Tempo_3 et teste
			goto	DELAI_2_3		; pas nul, boucler sur DELAI_1_2
			decfsz	Tempo_2_LCD,F	; nul, decremente Tempo_2 et teste
			goto	DELAI_2_2		; pas nul, boucler sur DELAI_1_1
			decfsz	Tempo_1_LCD,F	; nul, decremente Tempo_1 et teste
			goto	DELAI_2_1		; pas nul, boucler sur DELAI_1
			return			